.proc reset_handler
  sei               ; ignore interrupts for now
  cld

  jsr graphics_turn_off

  stx $4010
  cld               ; disables decimal
  dex
  ldx #$ff          ; init stack
  txs

vBlankWait1:
  bit PPUSTATUS_2002  
  bpl vBlankWait1

  jsr clear_pal

  bit PPUSTATUS_2002

  bit $4015
  lda #$40
  sta $4017
  lda #$0f
  sta $4015

vblankwait:
  bit PPUSTATUS_2002
  bpl vblankwait

  ldx #$00
  lda #$00
clear_zeropage:
  sta $00,x
  inx
  bne clear_zeropage
  lda #$ff
full_clear_oam:
  sta $200,x
  inx
  bne full_clear_oam

  lda #$00
  sta flickerflag ; start as no flicker
  sta oam_pos

vBlankWait2:

  bit PPUSTATUS_2002
  BPL vBlankWait2   


  lda #$0f
clear_palbuffer:
  sta PALBUFFER,x
  inx
  cpx #$20
  bne clear_palbuffer

  jsr clear_nams

  lda #$01
  ;sta scroll_x_spd
  sta fadestate
  sta gamestate ; set game state to "setup title"
  lda #$80  
  sta p1_speed_x
  lda #$20
  sta p1_y
  lda #$80
  sta p1_x
  lda #$01
  sta pal_cycle
  sta scroll_dir
  lda #GROUND

vBlankWait3:

  bit PPUSTATUS_2002
  BPL vBlankWait3


  lda #<music_data
  tax 
  lda #>music_data
  tay 
  jsr FamiToneInit

vBlankWait4:

  bit PPUSTATUS_2002
  BPL vBlankWait4

  lda #<sfx_data
  tax 
  lda #>sfx_data
  tay 
  jsr FamiToneSfxInit

vblankwait5:
  bit PPUSTATUS_2002
  bpl vblankwait5

  jsr graphics_turn_on

  jmp main
.endproc